/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package com.example.demoavrojava.avro;

import org.apache.avro.specific.SpecificData;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

@SuppressWarnings("all")
@org.apache.avro.specific.AvroGenerated
public class Charge extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = 4198944658569250138L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"Charge\",\"namespace\":\"com.example.demoavrojava.avro\",\"fields\":[{\"name\":\"cardNo\",\"type\":\"string\"},{\"name\":\"expiredDate\",\"type\":\"string\"},{\"name\":\"cvv\",\"type\":\"string\"},{\"name\":\"amount\",\"type\":\"int\"},{\"name\":\"status\",\"type\":\"string\"},{\"name\":\"id\",\"type\":\"string\"},{\"name\":\"brand\",\"type\":\"string\"}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static SpecificData MODEL$ = new SpecificData();

  private static final BinaryMessageEncoder<Charge> ENCODER =
      new BinaryMessageEncoder<Charge>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<Charge> DECODER =
      new BinaryMessageDecoder<Charge>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   */
  public static BinaryMessageDecoder<Charge> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   */
  public static BinaryMessageDecoder<Charge> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<Charge>(MODEL$, SCHEMA$, resolver);
  }

  /** Serializes this Charge to a ByteBuffer. */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /** Deserializes a Charge from a ByteBuffer. */
  public static Charge fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

  @Deprecated public java.lang.CharSequence cardNo;
  @Deprecated public java.lang.CharSequence expiredDate;
  @Deprecated public java.lang.CharSequence cvv;
  @Deprecated public int amount;
  @Deprecated public java.lang.CharSequence status;
  @Deprecated public java.lang.CharSequence id;
  @Deprecated public java.lang.CharSequence brand;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public Charge() {}

  /**
   * All-args constructor.
   * @param cardNo The new value for cardNo
   * @param expiredDate The new value for expiredDate
   * @param cvv The new value for cvv
   * @param amount The new value for amount
   * @param status The new value for status
   * @param id The new value for id
   * @param brand The new value for brand
   */
  public Charge(java.lang.CharSequence cardNo, java.lang.CharSequence expiredDate, java.lang.CharSequence cvv, java.lang.Integer amount, java.lang.CharSequence status, java.lang.CharSequence id, java.lang.CharSequence brand) {
    this.cardNo = cardNo;
    this.expiredDate = expiredDate;
    this.cvv = cvv;
    this.amount = amount;
    this.status = status;
    this.id = id;
    this.brand = brand;
  }

  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return cardNo;
    case 1: return expiredDate;
    case 2: return cvv;
    case 3: return amount;
    case 4: return status;
    case 5: return id;
    case 6: return brand;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: cardNo = (java.lang.CharSequence)value$; break;
    case 1: expiredDate = (java.lang.CharSequence)value$; break;
    case 2: cvv = (java.lang.CharSequence)value$; break;
    case 3: amount = (java.lang.Integer)value$; break;
    case 4: status = (java.lang.CharSequence)value$; break;
    case 5: id = (java.lang.CharSequence)value$; break;
    case 6: brand = (java.lang.CharSequence)value$; break;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  /**
   * Gets the value of the 'cardNo' field.
   * @return The value of the 'cardNo' field.
   */
  public java.lang.CharSequence getCardNo() {
    return cardNo;
  }

  /**
   * Sets the value of the 'cardNo' field.
   * @param value the value to set.
   */
  public void setCardNo(java.lang.CharSequence value) {
    this.cardNo = value;
  }

  /**
   * Gets the value of the 'expiredDate' field.
   * @return The value of the 'expiredDate' field.
   */
  public java.lang.CharSequence getExpiredDate() {
    return expiredDate;
  }

  /**
   * Sets the value of the 'expiredDate' field.
   * @param value the value to set.
   */
  public void setExpiredDate(java.lang.CharSequence value) {
    this.expiredDate = value;
  }

  /**
   * Gets the value of the 'cvv' field.
   * @return The value of the 'cvv' field.
   */
  public java.lang.CharSequence getCvv() {
    return cvv;
  }

  /**
   * Sets the value of the 'cvv' field.
   * @param value the value to set.
   */
  public void setCvv(java.lang.CharSequence value) {
    this.cvv = value;
  }

  /**
   * Gets the value of the 'amount' field.
   * @return The value of the 'amount' field.
   */
  public java.lang.Integer getAmount() {
    return amount;
  }

  /**
   * Sets the value of the 'amount' field.
   * @param value the value to set.
   */
  public void setAmount(java.lang.Integer value) {
    this.amount = value;
  }

  /**
   * Gets the value of the 'status' field.
   * @return The value of the 'status' field.
   */
  public java.lang.CharSequence getStatus() {
    return status;
  }

  /**
   * Sets the value of the 'status' field.
   * @param value the value to set.
   */
  public void setStatus(java.lang.CharSequence value) {
    this.status = value;
  }

  /**
   * Gets the value of the 'id' field.
   * @return The value of the 'id' field.
   */
  public java.lang.CharSequence getId() {
    return id;
  }

  /**
   * Sets the value of the 'id' field.
   * @param value the value to set.
   */
  public void setId(java.lang.CharSequence value) {
    this.id = value;
  }

  /**
   * Gets the value of the 'brand' field.
   * @return The value of the 'brand' field.
   */
  public java.lang.CharSequence getBrand() {
    return brand;
  }

  /**
   * Sets the value of the 'brand' field.
   * @param value the value to set.
   */
  public void setBrand(java.lang.CharSequence value) {
    this.brand = value;
  }

  /**
   * Creates a new Charge RecordBuilder.
   * @return A new Charge RecordBuilder
   */
  public static com.example.demoavrojava.avro.Charge.Builder newBuilder() {
    return new com.example.demoavrojava.avro.Charge.Builder();
  }

  /**
   * Creates a new Charge RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new Charge RecordBuilder
   */
  public static com.example.demoavrojava.avro.Charge.Builder newBuilder(com.example.demoavrojava.avro.Charge.Builder other) {
    return new com.example.demoavrojava.avro.Charge.Builder(other);
  }

  /**
   * Creates a new Charge RecordBuilder by copying an existing Charge instance.
   * @param other The existing instance to copy.
   * @return A new Charge RecordBuilder
   */
  public static com.example.demoavrojava.avro.Charge.Builder newBuilder(com.example.demoavrojava.avro.Charge other) {
    return new com.example.demoavrojava.avro.Charge.Builder(other);
  }

  /**
   * RecordBuilder for Charge instances.
   */
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<Charge>
    implements org.apache.avro.data.RecordBuilder<Charge> {

    private java.lang.CharSequence cardNo;
    private java.lang.CharSequence expiredDate;
    private java.lang.CharSequence cvv;
    private int amount;
    private java.lang.CharSequence status;
    private java.lang.CharSequence id;
    private java.lang.CharSequence brand;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(com.example.demoavrojava.avro.Charge.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.cardNo)) {
        this.cardNo = data().deepCopy(fields()[0].schema(), other.cardNo);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.expiredDate)) {
        this.expiredDate = data().deepCopy(fields()[1].schema(), other.expiredDate);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.cvv)) {
        this.cvv = data().deepCopy(fields()[2].schema(), other.cvv);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.amount)) {
        this.amount = data().deepCopy(fields()[3].schema(), other.amount);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.status)) {
        this.status = data().deepCopy(fields()[4].schema(), other.status);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.id)) {
        this.id = data().deepCopy(fields()[5].schema(), other.id);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.brand)) {
        this.brand = data().deepCopy(fields()[6].schema(), other.brand);
        fieldSetFlags()[6] = true;
      }
    }

    /**
     * Creates a Builder by copying an existing Charge instance
     * @param other The existing instance to copy.
     */
    private Builder(com.example.demoavrojava.avro.Charge other) {
            super(SCHEMA$);
      if (isValidValue(fields()[0], other.cardNo)) {
        this.cardNo = data().deepCopy(fields()[0].schema(), other.cardNo);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.expiredDate)) {
        this.expiredDate = data().deepCopy(fields()[1].schema(), other.expiredDate);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.cvv)) {
        this.cvv = data().deepCopy(fields()[2].schema(), other.cvv);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.amount)) {
        this.amount = data().deepCopy(fields()[3].schema(), other.amount);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.status)) {
        this.status = data().deepCopy(fields()[4].schema(), other.status);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.id)) {
        this.id = data().deepCopy(fields()[5].schema(), other.id);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.brand)) {
        this.brand = data().deepCopy(fields()[6].schema(), other.brand);
        fieldSetFlags()[6] = true;
      }
    }

    /**
      * Gets the value of the 'cardNo' field.
      * @return The value.
      */
    public java.lang.CharSequence getCardNo() {
      return cardNo;
    }

    /**
      * Sets the value of the 'cardNo' field.
      * @param value The value of 'cardNo'.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder setCardNo(java.lang.CharSequence value) {
      validate(fields()[0], value);
      this.cardNo = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'cardNo' field has been set.
      * @return True if the 'cardNo' field has been set, false otherwise.
      */
    public boolean hasCardNo() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'cardNo' field.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder clearCardNo() {
      cardNo = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'expiredDate' field.
      * @return The value.
      */
    public java.lang.CharSequence getExpiredDate() {
      return expiredDate;
    }

    /**
      * Sets the value of the 'expiredDate' field.
      * @param value The value of 'expiredDate'.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder setExpiredDate(java.lang.CharSequence value) {
      validate(fields()[1], value);
      this.expiredDate = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'expiredDate' field has been set.
      * @return True if the 'expiredDate' field has been set, false otherwise.
      */
    public boolean hasExpiredDate() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'expiredDate' field.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder clearExpiredDate() {
      expiredDate = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'cvv' field.
      * @return The value.
      */
    public java.lang.CharSequence getCvv() {
      return cvv;
    }

    /**
      * Sets the value of the 'cvv' field.
      * @param value The value of 'cvv'.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder setCvv(java.lang.CharSequence value) {
      validate(fields()[2], value);
      this.cvv = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'cvv' field has been set.
      * @return True if the 'cvv' field has been set, false otherwise.
      */
    public boolean hasCvv() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'cvv' field.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder clearCvv() {
      cvv = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'amount' field.
      * @return The value.
      */
    public java.lang.Integer getAmount() {
      return amount;
    }

    /**
      * Sets the value of the 'amount' field.
      * @param value The value of 'amount'.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder setAmount(int value) {
      validate(fields()[3], value);
      this.amount = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'amount' field has been set.
      * @return True if the 'amount' field has been set, false otherwise.
      */
    public boolean hasAmount() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'amount' field.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder clearAmount() {
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'status' field.
      * @return The value.
      */
    public java.lang.CharSequence getStatus() {
      return status;
    }

    /**
      * Sets the value of the 'status' field.
      * @param value The value of 'status'.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder setStatus(java.lang.CharSequence value) {
      validate(fields()[4], value);
      this.status = value;
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'status' field has been set.
      * @return True if the 'status' field has been set, false otherwise.
      */
    public boolean hasStatus() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'status' field.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder clearStatus() {
      status = null;
      fieldSetFlags()[4] = false;
      return this;
    }

    /**
      * Gets the value of the 'id' field.
      * @return The value.
      */
    public java.lang.CharSequence getId() {
      return id;
    }

    /**
      * Sets the value of the 'id' field.
      * @param value The value of 'id'.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder setId(java.lang.CharSequence value) {
      validate(fields()[5], value);
      this.id = value;
      fieldSetFlags()[5] = true;
      return this;
    }

    /**
      * Checks whether the 'id' field has been set.
      * @return True if the 'id' field has been set, false otherwise.
      */
    public boolean hasId() {
      return fieldSetFlags()[5];
    }


    /**
      * Clears the value of the 'id' field.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder clearId() {
      id = null;
      fieldSetFlags()[5] = false;
      return this;
    }

    /**
      * Gets the value of the 'brand' field.
      * @return The value.
      */
    public java.lang.CharSequence getBrand() {
      return brand;
    }

    /**
      * Sets the value of the 'brand' field.
      * @param value The value of 'brand'.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder setBrand(java.lang.CharSequence value) {
      validate(fields()[6], value);
      this.brand = value;
      fieldSetFlags()[6] = true;
      return this;
    }

    /**
      * Checks whether the 'brand' field has been set.
      * @return True if the 'brand' field has been set, false otherwise.
      */
    public boolean hasBrand() {
      return fieldSetFlags()[6];
    }


    /**
      * Clears the value of the 'brand' field.
      * @return This builder.
      */
    public com.example.demoavrojava.avro.Charge.Builder clearBrand() {
      brand = null;
      fieldSetFlags()[6] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public Charge build() {
      try {
        Charge record = new Charge();
        record.cardNo = fieldSetFlags()[0] ? this.cardNo : (java.lang.CharSequence) defaultValue(fields()[0]);
        record.expiredDate = fieldSetFlags()[1] ? this.expiredDate : (java.lang.CharSequence) defaultValue(fields()[1]);
        record.cvv = fieldSetFlags()[2] ? this.cvv : (java.lang.CharSequence) defaultValue(fields()[2]);
        record.amount = fieldSetFlags()[3] ? this.amount : (java.lang.Integer) defaultValue(fields()[3]);
        record.status = fieldSetFlags()[4] ? this.status : (java.lang.CharSequence) defaultValue(fields()[4]);
        record.id = fieldSetFlags()[5] ? this.id : (java.lang.CharSequence) defaultValue(fields()[5]);
        record.brand = fieldSetFlags()[6] ? this.brand : (java.lang.CharSequence) defaultValue(fields()[6]);
        return record;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<Charge>
    WRITER$ = (org.apache.avro.io.DatumWriter<Charge>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<Charge>
    READER$ = (org.apache.avro.io.DatumReader<Charge>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

}
